## GtkFileChooser GtkFileChooser — File chooser interface used by GtkFileChooserWidget and GtkFileChooserDialog |

## Functions

void | gtk_file_chooser_set_action ()
GtkFileChooserAction | gtk_file_chooser_get_action ()
void | gtk_file_chooser_set_local_only ()
gboolean | gtk_file_chooser_get_local_only ()
void | gtk_file_chooser_set_select_multiple ()
gboolean | gtk_file_chooser_get_select_multiple ()
void | gtk_file_chooser_set_show_hidden ()
gboolean | gtk_file_chooser_get_show_hidden ()
void | gtk_file_chooser_set_do_overwrite_confirmation ()
gboolean | gtk_file_chooser_get_do_overwrite_confirmation ()
void | gtk_file_chooser_set_create_folders ()
gboolean | gtk_file_chooser_get_create_folders ()
void | gtk_file_chooser_set_current_name ()
gchar * | gtk_file_chooser_get_current_name ()
gchar * | gtk_file_chooser_get_filename ()
gboolean | gtk_file_chooser_set_filename ()
gboolean | gtk_file_chooser_select_filename ()
void | gtk_file_chooser_unselect_filename ()
void | gtk_file_chooser_select_all ()
void | gtk_file_chooser_unselect_all ()
GSList * | gtk_file_chooser_get_filenames ()
gboolean | gtk_file_chooser_set_current_folder ()
gchar * | gtk_file_chooser_get_current_folder ()
gchar * | gtk_file_chooser_get_uri ()
gboolean | gtk_file_chooser_set_uri ()
gboolean | gtk_file_chooser_select_uri ()
void | gtk_file_chooser_unselect_uri ()
GSList * | gtk_file_chooser_get_uris ()
gboolean | gtk_file_chooser_set_current_folder_uri ()
gchar * | gtk_file_chooser_get_current_folder_uri ()
void | gtk_file_chooser_set_preview_widget ()
GtkWidget * | gtk_file_chooser_get_preview_widget ()
void | gtk_file_chooser_set_preview_widget_active ()
gboolean | gtk_file_chooser_get_preview_widget_active ()
void | gtk_file_chooser_set_use_preview_label ()
gboolean | gtk_file_chooser_get_use_preview_label ()
char * | gtk_file_chooser_get_preview_filename ()
char * | gtk_file_chooser_get_preview_uri ()
void | gtk_file_chooser_set_extra_widget ()
GtkWidget * | gtk_file_chooser_get_extra_widget ()
void | gtk_file_chooser_add_choice ()
void | gtk_file_chooser_remove_choice ()
void | gtk_file_chooser_set_choice ()
const char * | gtk_file_chooser_get_choice ()
void | gtk_file_chooser_add_filter ()
void | gtk_file_chooser_remove_filter ()
GSList * | gtk_file_chooser_list_filters ()
void | gtk_file_chooser_set_filter ()
GtkFileFilter * | gtk_file_chooser_get_filter ()
gboolean | gtk_file_chooser_add_shortcut_folder ()
gboolean | gtk_file_chooser_remove_shortcut_folder ()
GSList * | gtk_file_chooser_list_shortcut_folders ()
gboolean | gtk_file_chooser_add_shortcut_folder_uri ()
gboolean | gtk_file_chooser_remove_shortcut_folder_uri ()
GSList * | gtk_file_chooser_list_shortcut_folder_uris ()
GFile * | gtk_file_chooser_get_current_folder_file ()
GFile * | gtk_file_chooser_get_file ()
GSList * | gtk_file_chooser_get_files ()
GFile * | gtk_file_chooser_get_preview_file ()
gboolean | gtk_file_chooser_select_file ()
gboolean | gtk_file_chooser_set_current_folder_file ()
gboolean | gtk_file_chooser_set_file ()
void | gtk_file_chooser_unselect_file ()

## Properties

GtkFileChooserAction | action | Read / Write
gboolean | create-folders | Read / Write
gboolean | do-overwrite-confirmation | Read / Write
GtkWidget * | extra-widget | Read / Write
GtkFileFilter * | filter | Read / Write
gboolean | local-only | Read / Write
GtkWidget * | preview-widget | Read / Write
gboolean | preview-widget-active | Read / Write
gboolean | select-multiple | Read / Write
gboolean | show-hidden | Read / Write
gboolean | use-preview-label | Read / Write

## Signals

GtkFileChooserConfirmation | confirm-overwrite | Run Last
void | current-folder-changed | Run Last
void | file-activated | Run Last
void | selection-changed | Run Last
void | update-preview | Run Last

## Types and Values

| GtkFileChooser
enum | GtkFileChooserAction
enum | GtkFileChooserConfirmation
#define | GTK_FILE_CHOOSER_ERROR
enum | GtkFileChooserError

## Object Hierarchy

        GInterface
        ╰── GtkFileChooser

## Prerequisites

GtkFileChooser requires GObject.

## Known Implementations

GtkFileChooser is implemented by GtkFileChooserButton, GtkFileChooserDialog and GtkFileChooserWidget.

## Includes

    #include <gtk/gtk.h>

## Description

GtkFileChooser is an interface that can be implemented by file selection widgets. In GTK+, the main objects that implement this interface are GtkFileChooserWidget, GtkFileChooserDialog, and GtkFileChooserButton. You do not need to write an object that implements the GtkFileChooser interface unless you are trying to adapt an existing file selector to expose a standard programming interface.

GtkFileChooser allows for shortcuts to various places in the filesystem. In the default implementation these are displayed in the left pane. It may be a bit confusing at first that these shortcuts come from various sources and in various flavours, so lets explain the terminology here:

- Bookmarks: are created by the user, by dragging folders from the right pane to the left pane, or by using the “Add”. Bookmarks can be renamed and deleted by the user.

- Shortcuts: can be provided by the application. For example, a Paint program may want to add a shortcut for a Clipart folder. Shortcuts cannot be modified by the user.

- Volumes: are provided by the underlying filesystem abstraction. They are the “roots” of the filesystem.

### File Names and Encodings

When the user is finished selecting files in a GtkFileChooser, your program can get the selected names either as filenames or as URIs. For URIs, the normal escaping rules are applied if the URI contains non-ASCII characters. However, filenames are always returned in the character set specified by the `G_FILENAME_ENCODING` environment variable. Please see the GLib documentation for more details about this variable.

This means that while you can pass the result of `gtk_file_chooser_get_filename()` to `g_open()` or `g_fopen()`, you may not be able to directly set it as the text of a GtkLabel widget unless you convert it first to UTF-8, which all GTK+ widgets expect. You should use `g_filename_to_utf8()` to convert filenames into strings that can be passed to GTK+ widgets.

### Adding a Preview Widget

You can add a custom preview widget to a file chooser and then get notification about when the preview needs to be updated. To install a preview widget, use `gtk_file_chooser_set_preview_widget()`. Then, connect to the “update-preview” signal to get notified when you need to update the contents of the preview.

Your callback should use `gtk_file_chooser_get_preview_filename()` to see what needs previewing. Once you have generated the preview for the corresponding file, you must call `gtk_file_chooser_set_preview_widget_active()` with a boolean flag that indicates whether your callback could successfully generate a preview.

#### Example: Using a Preview Widget

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    {
      GtkImage *preview;

      ...

      preview = gtk_image_new ();

      gtk_file_chooser_set_preview_widget (my_file_chooser, preview);
      g_signal_connect (my_file_chooser, "update-preview",
    		    G_CALLBACK (update_preview_cb), preview);
    }

    static void
    update_preview_cb (GtkFileChooser *file_chooser, gpointer data)
    {
      GtkWidget *preview;
      char *filename;
      GdkPixbuf *pixbuf;
      gboolean have_preview;

      preview = GTK_WIDGET (data);
      filename = gtk_file_chooser_get_preview_filename (file_chooser);

      pixbuf = gdk_pixbuf_new_from_file_at_size (filename, 128, 128, NULL);
      have_preview = (pixbuf != NULL);
      g_free (filename);

      gtk_image_set_from_pixbuf (GTK_IMAGE (preview), pixbuf);
      if (pixbuf)
        g_object_unref (pixbuf);

      gtk_file_chooser_set_preview_widget_active (file_chooser, have_preview);
    }

### Adding Extra Widgets

You can add extra widgets to a file chooser to provide options that are not present in the default design. For example, you can add a toggle button to give the user the option to open a file in read-only mode. You can use `gtk_file_chooser_set_extra_widget()` to insert additional widgets in a file chooser.

An example for adding extra widgets:

    1
    2
    3
    4
    5
    6
    7
    8
    GtkWidget *toggle;

    ...

    toggle = gtk_check_button_new_with_label ("Open file read-only");
    gtk_widget_show (toggle);
    gtk_file_chooser_set_extra_widget (my_file_chooser, toggle);
    }

If you want to set more than one extra widget in the file chooser, you can a container such as a GtkBox or a GtkGrid and include your widgets in it. Then, set the container as the whole extra widget.

## Functions

### gtk_file_chooser_set_action ()

    void
    gtk_file_chooser_set_action (GtkFileChooser *chooser,
                                 GtkFileChooserAction action);

Sets the type of operation that the chooser is performing; the user interface is adapted to suit the selected action. For example, an option to create a new folder might be shown if the action is `GTK_FILE_CHOOSER_ACTION_SAVE` but not if the action is `GTK_FILE_CHOOSER_ACTION_OPEN`.

#### Parameters

chooser | a GtkFileChooser |
action | the action that the file selector is performing |

Since: 2.4

### gtk_file_chooser_get_action ()

    GtkFileChooserAction
    gtk_file_chooser_get_action (GtkFileChooser *chooser);

Gets the type of operation that the file chooser is performing; see `gtk_file_chooser_set_action()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the action that the file selector is performing

Since: 2.4

### gtk_file_chooser_set_local_only ()

    void
    gtk_file_chooser_set_local_only (GtkFileChooser *chooser,
                                     gboolean local_only);

Sets whether only local files can be selected in the file selector. If `local_only` is `TRUE` (the default), then the selected file or files are guaranteed to be accessible through the operating systems native file system and therefore the application only needs to worry about the filename functions in GtkFileChooser, like `gtk_file_chooser_get_filename()`, rather than the URI functions like `gtk_file_chooser_get_uri()`,

On some systems non-native files may still be available using the native filesystem via a userspace filesystem (FUSE).

#### Parameters

chooser | a GtkFileChooser |
local_only | `TRUE` if only local files can be selected |

Since: 2.4

### gtk_file_chooser_get_local_only ()

    gboolean
    gtk_file_chooser_get_local_only (GtkFileChooser *chooser);

Gets whether only local files can be selected in the file selector. See `gtk_file_chooser_set_local_only()`

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if only local files can be selected.

Since: 2.4

### gtk_file_chooser_set_select_multiple ()

    void
    gtk_file_chooser_set_select_multiple (GtkFileChooser *chooser,
                                          gboolean select_multiple);

Sets whether multiple files can be selected in the file selector. This is only relevant if the action is set to be `GTK_FILE_CHOOSER_ACTION_OPEN` or `GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER`.

#### Parameters

chooser | a GtkFileChooser |
select_multiple | `TRUE` if multiple files can be selected. |

Since: 2.4

### gtk_file_chooser_get_select_multiple ()

    gboolean
    gtk_file_chooser_get_select_multiple (GtkFileChooser *chooser);

Gets whether multiple files can be selected in the file selector. See `gtk_file_chooser_set_select_multiple()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if multiple files can be selected.

Since: 2.4

### gtk_file_chooser_set_show_hidden ()

    void
    gtk_file_chooser_set_show_hidden (GtkFileChooser *chooser,
                                      gboolean show_hidden);

Sets whether hidden files and folders are displayed in the file selector.

#### Parameters

chooser | a GtkFileChooser |
show_hidden | `TRUE` if hidden files and folders should be displayed. |

Since: 2.6

### gtk_file_chooser_get_show_hidden ()

    gboolean
    gtk_file_chooser_get_show_hidden (GtkFileChooser *chooser);

Gets whether hidden files and folders are displayed in the file selector. See `gtk_file_chooser_set_show_hidden()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if hidden files and folders are displayed.

Since: 2.6

### gtk_file_chooser_set_do_overwrite_confirmation ()

    void
    gtk_file_chooser_set_do_overwrite_confirmation
                                   (GtkFileChooser *chooser,
                                    gboolean do_overwrite_confirmation);

Sets whether a file chooser in `GTK_FILE_CHOOSER_ACTION_SAVE` mode will present a confirmation dialog if the user types a file name that already exists. This is `FALSE` by default.

If set to `TRUE`, the `chooser` will emit the “confirm-overwrite” signal when appropriate.

If all you need is the stock confirmation dialog, set this property to `TRUE`. You can override the way confirmation is done by actually handling the “confirm-overwrite” signal; please refer to its documentation for the details.

#### Parameters

chooser | a GtkFileChooser |
do_overwrite_confirmation | whether to confirm overwriting in save mode |

Since: 2.8

### gtk_file_chooser_get_do_overwrite_confirmation ()

    gboolean
    gtk_file_chooser_get_do_overwrite_confirmation
                                   (GtkFileChooser *chooser);

Queries whether a file chooser is set to confirm for overwriting when the user types a file name that already exists.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if the file chooser will present a confirmation dialog; `FALSE` otherwise.

Since: 2.8

### gtk_file_chooser_set_create_folders ()

    void
    gtk_file_chooser_set_create_folders (GtkFileChooser *chooser,
                                         gboolean create_folders);

Sets whether file choser will offer to create new folders. This is only relevant if the action is not set to be `GTK_FILE_CHOOSER_ACTION_OPEN`.

#### Parameters

chooser | a GtkFileChooser |
create_folders | `TRUE` if the Create Folder button should be displayed |

Since: 2.18

### gtk_file_chooser_get_create_folders ()

    gboolean
    gtk_file_chooser_get_create_folders (GtkFileChooser *chooser);

Gets whether file choser will offer to create new folders. See `gtk_file_chooser_set_create_folders()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if the Create Folder button should be displayed.

Since: 2.18

### gtk_file_chooser_set_current_name ()

    void
    gtk_file_chooser_set_current_name (GtkFileChooser *chooser,
                                       const gchar *name);

Sets the current name in the file selector, as if entered by the user. Note that the name passed in here is a UTF-8 string rather than a filename. This function is meant for such uses as a suggested name in a “Save As...” dialog. You can pass “Untitled.doc” or a similarly suitable suggestion for the `name` .

If you want to preselect a particular existing file, you should use `gtk_file_chooser_set_filename()` or `gtk_file_chooser_set_uri()` instead. Please see the documentation for those functions for an example of using `gtk_file_chooser_set_current_name()` as well.

#### Parameters

chooser | a GtkFileChooser |
name | the filename to use, as a UTF-8 string. | [type utf8]

Since: 2.4

### gtk_file_chooser_get_current_name ()

    gchar *
    gtk_file_chooser_get_current_name (GtkFileChooser *chooser);

Gets the current name in the file selector, as entered by the user in the text entry for “Name”.

This is meant to be used in save dialogs, to get the currently typed filename when the file itself does not exist yet. For example, an application that adds a custom extra widget to the file chooser for “file format” may want to change the extension of the typed filename based on the chosen format, say, from “.jpg” to “.png”.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

The raw text from the file chooser’s “Name” entry. Free this with `g_free()`. Note that this string is not a full pathname or URI; it is whatever the contents of the entry are. Note also that this string is in UTF-8 encoding, which is not necessarily the system’s encoding for filenames.

Since: 3.10

### gtk_file_chooser_get_filename ()

    gchar *
    gtk_file_chooser_get_filename (GtkFileChooser *chooser);

Gets the filename for the currently selected file in the file selector. The filename is returned as an absolute path. If multiple files are selected, one of the filenames will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

The currently selected filename, or `NULL` if no file is selected, or the selected file can't be represented with a local filename. Free with `g_free()`.

[nullable][type filename]

Since: 2.4

### gtk_file_chooser_set_filename ()

    gboolean
    gtk_file_chooser_set_filename (GtkFileChooser *chooser,
                                   const char *filename);

Sets `filename` as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list; all other files will be unselected. If the `chooser` is in `GTK_FILE_CHOOSER_ACTION_SAVE` mode, the file’s base name will also appear in the dialog’s file name entry.

Note that the file must exist, or nothing will be done except for the directory change.

You should use this function only when implementing a save dialog for which you already have a file name to which the user may save. For example, when the user opens an existing file and then does Save As... to save a copy or a modified version. If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_filename (chooser, existing_filename);
      }

In the first case, the file chooser will present the user with useful suggestions as to where to save his new file. In the second case, the file’s existing location is already known, so the file chooser will use it.

#### Parameters

chooser | a GtkFileChooser |
filename | the filename to set as current. | [type filename]

#### Returns

Not useful.

Since: 2.4

### gtk_file_chooser_select_filename ()

    gboolean
    gtk_file_chooser_select_filename (GtkFileChooser *chooser,
                                      const char *filename);

Selects a filename. If the file name isn’t in the current folder of `chooser` , then the current folder of `chooser` will be changed to the folder containing `filename` .

#### Parameters

chooser | a GtkFileChooser |
filename | the filename to select. | [type filename]

#### Returns

Not useful.

See also: `gtk_file_chooser_set_filename()`

Since: 2.4

### gtk_file_chooser_unselect_filename ()

    void
    gtk_file_chooser_unselect_filename (GtkFileChooser *chooser,
                                        const char *filename);

Unselects a currently selected filename. If the filename is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

#### Parameters

chooser | a GtkFileChooser |
filename | the filename to unselect. | [type filename]

Since: 2.4

### gtk_file_chooser_select_all ()

    void
    gtk_file_chooser_select_all (GtkFileChooser *chooser);

Selects all the files in the current folder of a file chooser.

#### Parameters

chooser | a GtkFileChooser |

Since: 2.4

### gtk_file_chooser_unselect_all ()

    void
    gtk_file_chooser_unselect_all (GtkFileChooser *chooser);

Unselects all the files in the current folder of a file chooser.

#### Parameters

chooser | a GtkFileChooser |

Since: 2.4

### gtk_file_chooser_get_filenames ()

    GSList *
    gtk_file_chooser_get_filenames (GtkFileChooser *chooser);

Lists all the selected files and subfolders in the current folder of `chooser` . The returned names are full absolute paths. If files in the current folder cannot be represented as local filenames they will be ignored. (See `gtk_file_chooser_get_uris()`)

#### Parameters

chooser | a GtkFileChooser |

#### Returns

a GSList containing the filenames of all selected files and subfolders in the current folder. Free the returned list with `g_slist_free()`, and the filenames with `g_free()`.

[element-type filename][transfer full]

Since: 2.4

### gtk_file_chooser_set_current_folder ()

    gboolean
    gtk_file_chooser_set_current_folder (GtkFileChooser *chooser,
                                         const gchar *filename);

Sets the current folder for `chooser` from a local filename. The user will be shown the full contents of the current folder, plus user interface elements for navigating to other folders.

In general, you should not use this function. See the section on setting up a file chooser dialog for the rationale behind this.

#### Parameters

chooser | a GtkFileChooser |
filename | the full path of the new current folder. | [type filename]

#### Returns

Not useful.

Since: 2.4

### gtk_file_chooser_get_current_folder ()

    gchar *
    gtk_file_chooser_get_current_folder (GtkFileChooser *chooser);

Gets the current folder of `chooser` as a local filename. See `gtk_file_chooser_set_current_folder()`.

Note that this is the folder that the file chooser is currently displaying (e.g. "/home/username/Documents"), which is not the same as the currently-selected folder if the chooser is in `GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER` mode (e.g. "/home/username/Documents/selected-folder/". To get the currently-selected folder in that mode, use `gtk_file_chooser_get_uri()` as the usual way to get the selection.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the full path of the current folder, or `NULL` if the current path cannot be represented as a local filename. Free with `g_free()`. This function will also return `NULL` if the file chooser was unable to load the last folder that was requested from it; for example, as would be for calling `gtk_file_chooser_set_current_folder()` on a nonexistent folder.

[nullable][type filename]

Since: 2.4

### gtk_file_chooser_get_uri ()

    gchar *
    gtk_file_chooser_get_uri (GtkFileChooser *chooser);

Gets the URI for the currently selected file in the file selector. If multiple files are selected, one of the filenames will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

The currently selected URI, or `NULL` if no file is selected. If `gtk_file_chooser_set_local_only()` is set to `TRUE` (the default) a local URI will be returned for any FUSE locations. Free with `g_free()`.

[nullable][transfer full]

Since: 2.4

### gtk_file_chooser_set_uri ()

    gboolean
    gtk_file_chooser_set_uri (GtkFileChooser *chooser,
                              const char *uri);

Sets the file referred to by `uri` as the current file for the file chooser, by changing to the URI’s parent folder and actually selecting the URI in the list. If the `chooser` is `GTK_FILE_CHOOSER_ACTION_SAVE` mode, the URI’s base name will also appear in the dialog’s file name entry.

Note that the URI must exist, or nothing will be done except for the directory change.

You should use this function only when implementing a save dialog for which you already have a file name to which the user may save. For example, when the user opens an existing file and then does Save As... to save a copy or a modified version. If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_uri (chooser, existing_uri);
      }

In the first case, the file chooser will present the user with useful suggestions as to where to save his new file. In the second case, the file’s existing location is already known, so the file chooser will use it.

#### Parameters

chooser | a GtkFileChooser |
uri | the URI to set as current |

#### Returns

Not useful.

Since: 2.4

### gtk_file_chooser_select_uri ()

    gboolean
    gtk_file_chooser_select_uri (GtkFileChooser *chooser,
                                 const char *uri);

Selects the file to by `uri` . If the URI doesn’t refer to a file in the current folder of `chooser` , then the current folder of `chooser` will be changed to the folder containing `filename` .

#### Parameters

chooser | a GtkFileChooser |
uri | the URI to select |

#### Returns

Not useful.

Since: 2.4

### gtk_file_chooser_unselect_uri ()

    void
    gtk_file_chooser_unselect_uri (GtkFileChooser *chooser,
                                   const char *uri);

Unselects the file referred to by `uri` . If the file is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

#### Parameters

chooser | a GtkFileChooser |
uri | the URI to unselect |

Since: 2.4

### gtk_file_chooser_get_uris ()

    GSList *
    gtk_file_chooser_get_uris (GtkFileChooser *chooser);

Lists all the selected files and subfolders in the current folder of `chooser` . The returned names are full absolute URIs.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

a GSList containing the URIs of all selected files and subfolders in the current folder. Free the returned list with `g_slist_free()`, and the filenames with `g_free()`.

[element-type utf8][transfer full]

Since: 2.4

### gtk_file_chooser_set_current_folder_uri ()

    gboolean
    gtk_file_chooser_set_current_folder_uri
                                   (GtkFileChooser *chooser,
                                    const gchar *uri);

Sets the current folder for `chooser` from an URI. The user will be shown the full contents of the current folder, plus user interface elements for navigating to other folders.

In general, you should not use this function. See the section on setting up a file chooser dialog for the rationale behind this.

#### Parameters

chooser | a GtkFileChooser |
uri | the URI for the new current folder |

#### Returns

`TRUE` if the folder could be changed successfully, `FALSE` otherwise.

Since: 2.4

### gtk_file_chooser_get_current_folder_uri ()

    gchar *
    gtk_file_chooser_get_current_folder_uri
                                   (GtkFileChooser *chooser);

Gets the current folder of `chooser` as an URI. See `gtk_file_chooser_set_current_folder_uri()`.

Note that this is the folder that the file chooser is currently displaying (e.g. "file:///home/username/Documents"), which is not the same as the currently-selected folder if the chooser is in `GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER` mode (e.g. "file:///home/username/Documents/selected-folder/". To get the currently-selected folder in that mode, use `gtk_file_chooser_get_uri()` as the usual way to get the selection.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the URI for the current folder. Free with `g_free()`. This function will also return `NULL` if the file chooser was unable to load the last folder that was requested from it; for example, as would be for calling `gtk_file_chooser_set_current_folder_uri()` on a nonexistent folder.

[nullable][transfer full]

Since: 2.4

### gtk_file_chooser_set_preview_widget ()

    void
    gtk_file_chooser_set_preview_widget (GtkFileChooser *chooser,
                                         GtkWidget *preview_widget);

Sets an application-supplied widget to use to display a custom preview of the currently selected file. To implement a preview, after setting the preview widget, you connect to the “update-preview” signal, and call `gtk_file_chooser_get_preview_filename()` or `gtk_file_chooser_get_preview_uri()` on each change. If you can display a preview of the new file, update your widget and set the preview active using `gtk_file_chooser_set_preview_widget_active()`. Otherwise, set the preview inactive.

When there is no application-supplied preview widget, or the application-supplied preview widget is not active, the file chooser will display no preview at all.

#### Parameters

chooser | a GtkFileChooser |
preview_widget | widget for displaying preview. |

Since: 2.4

### gtk_file_chooser_get_preview_widget ()

    GtkWidget *
    gtk_file_chooser_get_preview_widget (GtkFileChooser *chooser);

Gets the current preview widget; see `gtk_file_chooser_set_preview_widget()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the current preview widget, or `NULL`.

[nullable][transfer none]

Since: 2.4

### gtk_file_chooser_set_preview_widget_active ()

    void
    gtk_file_chooser_set_preview_widget_active
                                   (GtkFileChooser *chooser,
                                    gboolean active);

Sets whether the preview widget set by `gtk_file_chooser_set_preview_widget()` should be shown for the current filename. When `active` is set to false, the file chooser may display an internally generated preview of the current file or it may display no preview at all. See `gtk_file_chooser_set_preview_widget()` for more details.

#### Parameters

chooser | a GtkFileChooser |
active | whether to display the user-specified preview widget |

Since: 2.4

### gtk_file_chooser_get_preview_widget_active ()

    gboolean
    gtk_file_chooser_get_preview_widget_active
                                   (GtkFileChooser *chooser);

Gets whether the preview widget set by `gtk_file_chooser_set_preview_widget()` should be shown for the current filename. See `gtk_file_chooser_set_preview_widget_active()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if the preview widget is active for the current filename.

Since: 2.4

### gtk_file_chooser_set_use_preview_label ()

    void
    gtk_file_chooser_set_use_preview_label
                                   (GtkFileChooser *chooser,
                                    gboolean use_label);

Sets whether the file chooser should display a stock label with the name of the file that is being previewed; the default is `TRUE`. Applications that want to draw the whole preview area themselves should set this to `FALSE` and display the name themselves in their preview widget.

See also: `gtk_file_chooser_set_preview_widget()`

#### Parameters

chooser | a GtkFileChooser |
use_label | whether to display a stock label with the name of the previewed file |

Since: 2.4

### gtk_file_chooser_get_use_preview_label ()

    gboolean
    gtk_file_chooser_get_use_preview_label
                                   (GtkFileChooser *chooser);

Gets whether a stock label should be drawn with the name of the previewed file. See `gtk_file_chooser_set_use_preview_label()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

`TRUE` if the file chooser is set to display a label with the name of the previewed file, `FALSE` otherwise.

### gtk_file_chooser_get_preview_filename ()

    char *
    gtk_file_chooser_get_preview_filename (GtkFileChooser *chooser);

Gets the filename that should be previewed in a custom preview widget. See `gtk_file_chooser_set_preview_widget()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the filename to preview, or `NULL` if no file is selected, or if the selected file cannot be represented as a local filename. Free with `g_free()`.

[nullable][type filename]

Since: 2.4

### gtk_file_chooser_get_preview_uri ()

    char *
    gtk_file_chooser_get_preview_uri (GtkFileChooser *chooser);

Gets the URI that should be previewed in a custom preview widget. See `gtk_file_chooser_set_preview_widget()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the URI for the file to preview, or `NULL` if no file is selected. Free with `g_free()`.

[nullable][transfer full]

Since: 2.4

### gtk_file_chooser_set_extra_widget ()

    void
    gtk_file_chooser_set_extra_widget (GtkFileChooser *chooser,
                                       GtkWidget *extra_widget);

Sets an application-supplied widget to provide extra options to the user.

#### Parameters

chooser | a GtkFileChooser |
extra_widget | widget for extra options |

Since: 2.4

### gtk_file_chooser_get_extra_widget ()

    GtkWidget *
    gtk_file_chooser_get_extra_widget (GtkFileChooser *chooser);

Gets the current extra widget; see `gtk_file_chooser_set_extra_widget()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the current extra widget, or `NULL`.

[nullable][transfer none]

Since: 2.4

### gtk_file_chooser_add_choice ()

    void
    gtk_file_chooser_add_choice (GtkFileChooser *chooser,
                                 const char *id,
                                 const char *label,
                                 const char **options,
                                 const char **option_labels);

Adds a 'choice' to the file chooser. This is typically implemented as a combobox or, for boolean choices, as a checkbutton. You can select a value using `gtk_file_chooser_set_choice()` before the dialog is shown, and you can obtain the user-selected value in the ::response signal handler using `gtk_file_chooser_get_choice()`.

Compare `gtk_file_chooser_set_extra_widget()`.

#### Parameters

chooser | a GtkFileChooser |
id | id for the added choice |
label | user-visible label for the added choice |
options | ids for the options of the choice, or `NULL` for a boolean choice. | [nullable][array zero-terminated=1]
option_labels | user-visible labels for the options, must be the same length as `options` . | [nullable][array zero-terminated=1]

Since: 3.22

### gtk_file_chooser_remove_choice ()

    void
    gtk_file_chooser_remove_choice (GtkFileChooser *chooser,
                                    const char *id);

Removes a 'choice' that has been added with `gtk_file_chooser_add_choice()`.

#### Parameters

chooser | a GtkFileChooser |
id | the ID of the choice to remove |

Since: 3.22

### gtk_file_chooser_set_choice ()

    void
    gtk_file_chooser_set_choice (GtkFileChooser *chooser,
                                 const char *id,
                                 const char *option);

Selects an option in a 'choice' that has been added with `gtk_file_chooser_add_choice()`. For a boolean choice, the possible options are "true" and "false".

#### Parameters

chooser | a GtkFileChooser |
id | the ID of the choice to set |
option | the ID of the option to select |

Since: 3.22

### gtk_file_chooser_get_choice ()

    const char *
    gtk_file_chooser_get_choice (GtkFileChooser *chooser,
                                 const char *id);

Gets the currently selected option in the 'choice' with the given ID.

#### Parameters

chooser | a GtkFileChooser |
id | the ID of the choice to get |

#### Returns

the ID of the currenly selected option

Since: 3.22

### gtk_file_chooser_add_filter ()

    void
    gtk_file_chooser_add_filter (GtkFileChooser *chooser,
                                 GtkFileFilter *filter);

Adds `filter` to the list of filters that the user can select between. When a filter is selected, only files that are passed by that filter are displayed.

Note that the `chooser` takes ownership of the filter, so you have to ref and sink it if you want to keep a reference.

#### Parameters

chooser | a GtkFileChooser |
filter | a GtkFileFilter. | [transfer full]

Since: 2.4

### gtk_file_chooser_remove_filter ()

    void
    gtk_file_chooser_remove_filter (GtkFileChooser *chooser,
                                    GtkFileFilter *filter);

Removes `filter` from the list of filters that the user can select between.

#### Parameters

chooser | a GtkFileChooser |
filter | a GtkFileFilter |

Since: 2.4

### gtk_file_chooser_list_filters ()

    GSList *
    gtk_file_chooser_list_filters (GtkFileChooser *chooser);

Lists the current set of user-selectable filters; see `gtk_file_chooser_add_filter()`, `gtk_file_chooser_remove_filter()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

a GSList containing the current set of user selectable filters. The contents of the list are owned by GTK+, but you must free the list itself with `g_slist_free()` when you are done with it.

[element-type GtkFileFilter][transfer container]

Since: 2.4

### gtk_file_chooser_set_filter ()

    void
    gtk_file_chooser_set_filter (GtkFileChooser *chooser,
                                 GtkFileFilter *filter);

Sets the current filter; only the files that pass the filter will be displayed. If the user-selectable list of filters is non-empty, then the filter should be one of the filters in that list. Setting the current filter when the list of filters is empty is useful if you want to restrict the displayed set of files without letting the user change it.

#### Parameters

chooser | a GtkFileChooser |
filter | a GtkFileFilter |

Since: 2.4

### gtk_file_chooser_get_filter ()

    GtkFileFilter *
    gtk_file_chooser_get_filter (GtkFileChooser *chooser);

Gets the current filter; see `gtk_file_chooser_set_filter()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the current filter, or `NULL`.

[nullable][transfer none]

Since: 2.4

### gtk_file_chooser_add_shortcut_folder ()

    gboolean
    gtk_file_chooser_add_shortcut_folder (GtkFileChooser *chooser,
                                          const char *folder,
                                          GError **error);

Adds a folder to be displayed with the shortcut folders in a file chooser. Note that shortcut folders do not get saved, as they are provided by the application. For example, you can use this to add a “/usr/share/mydrawprogram/Clipart” folder to the volume list.

#### Parameters

chooser | a GtkFileChooser |
folder | filename of the folder to add. | [type filename]
error | location to store error, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the folder could be added successfully, `FALSE` otherwise. In the latter case, the `error` will be set as appropriate.

Since: 2.4

### gtk_file_chooser_remove_shortcut_folder ()

    gboolean
    gtk_file_chooser_remove_shortcut_folder
                                   (GtkFileChooser *chooser,
                                    const char *folder,
                                    GError **error);

Removes a folder from a file chooser’s list of shortcut folders.

#### Parameters

chooser | a GtkFileChooser |
folder | filename of the folder to remove. | [type filename]
error | location to store error, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the operation succeeds, `FALSE` otherwise. In the latter case, the `error` will be set as appropriate.

See also: `gtk_file_chooser_add_shortcut_folder()`

Since: 2.4

### gtk_file_chooser_list_shortcut_folders ()

    GSList *
    gtk_file_chooser_list_shortcut_folders
                                   (GtkFileChooser *chooser);

Queries the list of shortcut folders in the file chooser, as set by `gtk_file_chooser_add_shortcut_folder()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

A list of folder filenames, or `NULL` if there are no shortcut folders. Free the returned list with `g_slist_free()`, and the filenames with `g_free()`.

[nullable][element-type filename][transfer full]

Since: 2.4

### gtk_file_chooser_add_shortcut_folder_uri ()

    gboolean
    gtk_file_chooser_add_shortcut_folder_uri
                                   (GtkFileChooser *chooser,
                                    const char *uri,
                                    GError **error);

Adds a folder URI to be displayed with the shortcut folders in a file chooser. Note that shortcut folders do not get saved, as they are provided by the application. For example, you can use this to add a “file:///usr/share/mydrawprogram/Clipart” folder to the volume list.

#### Parameters

chooser | a GtkFileChooser |
uri | URI of the folder to add |
error | location to store error, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the folder could be added successfully, `FALSE` otherwise. In the latter case, the `error` will be set as appropriate.

Since: 2.4

### gtk_file_chooser_remove_shortcut_folder_uri ()

    gboolean
    gtk_file_chooser_remove_shortcut_folder_uri
                                   (GtkFileChooser *chooser,
                                    const char *uri,
                                    GError **error);

Removes a folder URI from a file chooser’s list of shortcut folders.

#### Parameters

chooser | a GtkFileChooser |
uri | URI of the folder to remove |
error | location to store error, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the operation succeeds, `FALSE` otherwise. In the latter case, the `error` will be set as appropriate.

See also: `gtk_file_chooser_add_shortcut_folder_uri()`

Since: 2.4

### gtk_file_chooser_list_shortcut_folder_uris ()

    GSList *
    gtk_file_chooser_list_shortcut_folder_uris
                                   (GtkFileChooser *chooser);

Queries the list of shortcut folders in the file chooser, as set by `gtk_file_chooser_add_shortcut_folder_uri()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

A list of folder URIs, or `NULL` if there are no shortcut folders. Free the returned list with `g_slist_free()`, and the URIs with `g_free()`.

[nullable][element-type utf8][transfer full]

Since: 2.4

### gtk_file_chooser_get_current_folder_file ()

    GFile *
    gtk_file_chooser_get_current_folder_file
                                   (GtkFileChooser *chooser);

Gets the current folder of `chooser` as GFile. See `gtk_file_chooser_get_current_folder_uri()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the GFile for the current folder.

[nullable][transfer full]

Since: 2.14

### gtk_file_chooser_get_file ()

    GFile *
    gtk_file_chooser_get_file (GtkFileChooser *chooser);

Gets the GFile for the currently selected file in the file selector. If multiple files are selected, one of the files will be returned at random.

If the file chooser is in folder mode, this function returns the selected folder.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

a selected GFile. You own the returned file; use `g_object_unref()` to release it.

[transfer full]

Since: 2.14

### gtk_file_chooser_get_files ()

    GSList *
    gtk_file_chooser_get_files (GtkFileChooser *chooser);

Lists all the selected files and subfolders in the current folder of `chooser` as GFile. An internal function, see `gtk_file_chooser_get_uris()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

a GSList containing a GFile for each selected file and subfolder in the current folder. Free the returned list with `g_slist_free()`, and the files with `g_object_unref()`.

[element-type GFile][transfer full]

Since: 2.14

### gtk_file_chooser_get_preview_file ()

    GFile *
    gtk_file_chooser_get_preview_file (GtkFileChooser *chooser);

Gets the GFile that should be previewed in a custom preview Internal function, see `gtk_file_chooser_get_preview_uri()`.

#### Parameters

chooser | a GtkFileChooser |

#### Returns

the GFile for the file to preview, or `NULL` if no file is selected. Free with `g_object_unref()`.

[nullable][transfer full]

Since: 2.14

### gtk_file_chooser_select_file ()

    gboolean
    gtk_file_chooser_select_file (GtkFileChooser *chooser,
                                  GFile *file,
                                  GError **error);

Selects the file referred to by `file` . An internal function. See `_gtk_file_chooser_select_uri()`.

#### Parameters

chooser | a GtkFileChooser |
file | the file to select |
error | location to store error, or `NULL`. | [allow-none]

#### Returns

Not useful.

Since: 2.14

### gtk_file_chooser_set_current_folder_file ()

    gboolean
    gtk_file_chooser_set_current_folder_file
                                   (GtkFileChooser *chooser,
                                    GFile *file,
                                    GError **error);

Sets the current folder for `chooser` from a GFile. Internal function, see `gtk_file_chooser_set_current_folder_uri()`.

#### Parameters

chooser | a GtkFileChooser |
file | the GFile for the new folder |
error | location to store error, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the folder could be changed successfully, `FALSE` otherwise.

Since: 2.14

### gtk_file_chooser_set_file ()

    gboolean
    gtk_file_chooser_set_file (GtkFileChooser *chooser,
                               GFile *file,
                               GError **error);

Sets `file` as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list. If the `chooser` is in `GTK_FILE_CHOOSER_ACTION_SAVE` mode, the file’s base name will also appear in the dialog’s file name entry.

If the file name isn’t in the current folder of `chooser` , then the current folder of `chooser` will be changed to the folder containing `filename` . This is equivalent to a sequence of `gtk_file_chooser_unselect_all()` followed by `gtk_file_chooser_select_filename()`.

Note that the file must exist, or nothing will be done except for the directory change.

If you are implementing a save dialog, you should use this function if you already have a file name to which the user may save; for example, when the user opens an existing file and then does Save As... If you don’t have a file name already — for example, if the user just created a new file and is saving it for the first time, do not call this function. Instead, use something similar to this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    if (document_is_new)
      {
        // the user just created a new document
        gtk_file_chooser_set_current_folder_file (chooser, default_file_for_saving);
        gtk_file_chooser_set_current_name (chooser, "Untitled document");
      }
    else
      {
        // the user edited an existing document
        gtk_file_chooser_set_file (chooser, existing_file);
      }

#### Parameters

chooser | a GtkFileChooser |
file | the GFile to set as current |
error | location to store the error, or `NULL` to ignore errors. | [allow-none]

#### Returns

Not useful.

Since: 2.14

### gtk_file_chooser_unselect_file ()

    void
    gtk_file_chooser_unselect_file (GtkFileChooser *chooser,
                                    GFile *file);

Unselects the file referred to by `file` . If the file is not in the current directory, does not exist, or is otherwise not currently selected, does nothing.

#### Parameters

chooser | a GtkFileChooser |
file | a GFile |

Since: 2.14

## Types and Values

### GtkFileChooser

    typedef struct _GtkFileChooser GtkFileChooser;

### enum GtkFileChooserAction

Describes whether a GtkFileChooser is being used to open existing files or to save to a possibly new file.

#### Members

GTK_FILE_CHOOSER_ACTION_OPEN | Indicates open mode. The file chooser will only let the user pick an existing file. |
GTK_FILE_CHOOSER_ACTION_SAVE | Indicates save mode. The file chooser will let the user pick an existing file, or type in a new filename. |
GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER | Indicates an Open mode for selecting folders. The file chooser will let the user pick an existing folder. |
GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER | Indicates a mode for creating a new folder. The file chooser will let the user name an existing or new folder. |

### enum GtkFileChooserConfirmation

Used as a return value of handlers for the “confirm-overwrite” signal of a GtkFileChooser. This value determines whether the file chooser will present the stock confirmation dialog, accept the user’s choice of a filename, or let the user choose another filename.

#### Members

GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM | The file chooser will present its stock dialog to confirm about overwriting an existing file. |
GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME | The file chooser will terminate and accept the user’s choice of a file name. |
GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN | The file chooser will continue running, so as to let the user select another file name. |

Since: 2.8

### GTK_FILE_CHOOSER_ERROR

    #define GTK_FILE_CHOOSER_ERROR (gtk_file_chooser_error_quark ())

Used to get the GError quark for GtkFileChooser errors.

### enum GtkFileChooserError

These identify the various errors that can occur while calling GtkFileChooser functions.

#### Members

GTK_FILE_CHOOSER_ERROR_NONEXISTENT | Indicates that a file does not exist. |
GTK_FILE_CHOOSER_ERROR_BAD_FILENAME | Indicates a malformed filename. |
GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS | Indicates a duplicate path (e.g. when adding a bookmark). |
GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME | Indicates an incomplete hostname (e.g. "http://foo" without a slash after that). |

## Property Details

### The `“action”` property

      “action”                   GtkFileChooserAction

The type of operation that the file selector is performing.

Owner: GtkFileChooser

Flags: Read / Write

Default value: GTK_FILE_CHOOSER_ACTION_OPEN

### The `“create-folders”` property

      “create-folders”           gboolean

Whether a file chooser not in `GTK_FILE_CHOOSER_ACTION_OPEN` mode will offer the user to create new folders.

Owner: GtkFileChooser

Flags: Read / Write

Default value: TRUE

Since: 2.18

### The `“do-overwrite-confirmation”` property

      “do-overwrite-confirmation” gboolean

Whether a file chooser in `GTK_FILE_CHOOSER_ACTION_SAVE` mode will present an overwrite confirmation dialog if the user selects a file name that already exists.

Owner: GtkFileChooser

Flags: Read / Write

Default value: FALSE

Since: 2.8

### The `“extra-widget”` property

      “extra-widget”             GtkWidget *

Application supplied widget for extra options.

Owner: GtkFileChooser

Flags: Read / Write

### The `“filter”` property

      “filter”                   GtkFileFilter *

The current filter for selecting which files are displayed.

Owner: GtkFileChooser

Flags: Read / Write

### The `“local-only”` property

      “local-only”               gboolean

Whether the selected file(s) should be limited to local file: URLs.

Owner: GtkFileChooser

Flags: Read / Write

Default value: TRUE

### The `“preview-widget”` property

      “preview-widget”           GtkWidget *

Application supplied widget for custom previews.

Owner: GtkFileChooser

Flags: Read / Write

### The `“preview-widget-active”` property

      “preview-widget-active”    gboolean

Whether the application supplied widget for custom previews should be shown.

Owner: GtkFileChooser

Flags: Read / Write

Default value: TRUE

### The `“select-multiple”` property

      “select-multiple”          gboolean

Whether to allow multiple files to be selected.

Owner: GtkFileChooser

Flags: Read / Write

Default value: FALSE

### The `“show-hidden”` property

      “show-hidden”              gboolean

Whether the hidden files and folders should be displayed.

Owner: GtkFileChooser

Flags: Read / Write

Default value: FALSE

### The `“use-preview-label”` property

      “use-preview-label”        gboolean

Whether to display a stock label with the name of the previewed file.

Owner: GtkFileChooser

Flags: Read / Write

Default value: TRUE

## Signal Details

### The `“confirm-overwrite”` signal

    GtkFileChooserConfirmation
    user_function (GtkFileChooser *chooser,
                   gpointer        user_data)

This signal gets emitted whenever it is appropriate to present a confirmation dialog when the user has selected a file name that already exists. The signal only gets emitted when the file chooser is in `GTK_FILE_CHOOSER_ACTION_SAVE` mode.

Most applications just need to turn on the “do-overwrite-confirmation” property (or call the `gtk_file_chooser_set_do_overwrite_confirmation()` function), and they will automatically get a stock confirmation dialog. Applications which need to customize this behavior should do that, and also connect to the “confirm-overwrite” signal.

A signal handler for this signal must return a GtkFileChooserConfirmation value, which indicates the action to take. If the handler determines that the user wants to select a different filename, it should return `GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN`. If it determines that the user is satisfied with his choice of file name, it should return `GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME`. On the other hand, if it determines that the stock confirmation dialog should be used, it should return `GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM`. The following example illustrates this.

#### Custom confirmation

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    static GtkFileChooserConfirmation
    confirm_overwrite_callback (GtkFileChooser *chooser, gpointer data)
    {
      char *uri;

      uri = gtk_file_chooser_get_uri (chooser);

      if (is_uri_read_only (uri))
        {
          if (user_wants_to_replace_read_only_file (uri))
            return GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME;
          else
            return GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN;
        } else
          return GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM; // fall back to the default dialog
    }

    ...

    chooser = gtk_file_chooser_dialog_new (...);

    gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog), TRUE);
    g_signal_connect (chooser, "confirm-overwrite",
                      G_CALLBACK (confirm_overwrite_callback), NULL);

    if (gtk_dialog_run (chooser) == GTK_RESPONSE_ACCEPT)
            save_to_file (gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (chooser));

    gtk_widget_destroy (chooser);

#### Parameters

chooser | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

#### Returns

a GtkFileChooserConfirmation value that indicates which action to take after emitting the signal.

Flags: Run Last

Since: 2.8

### The `“current-folder-changed”` signal

    void
    user_function (GtkFileChooser *chooser,
                   gpointer        user_data)

This signal is emitted when the current folder in a GtkFileChooser changes. This can happen due to the user performing some action that changes folders, such as selecting a bookmark or visiting a folder on the file list. It can also happen as a result of calling a function to explicitly change the current folder in a file chooser.

Normally you do not need to connect to this signal, unless you need to keep track of which folder a file chooser is showing.

See also: `gtk_file_chooser_set_current_folder()`, `gtk_file_chooser_get_current_folder()`, `gtk_file_chooser_set_current_folder_uri()`, `gtk_file_chooser_get_current_folder_uri()`.

#### Parameters

chooser | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“file-activated”` signal

    void
    user_function (GtkFileChooser *chooser,
                   gpointer        user_data)

This signal is emitted when the user "activates" a file in the file chooser. This can happen by double-clicking on a file in the file list, or by pressing `Enter`.

Normally you do not need to connect to this signal. It is used internally by GtkFileChooserDialog to know when to activate the default button in the dialog.

See also: `gtk_file_chooser_get_filename()`, `gtk_file_chooser_get_filenames()`, `gtk_file_chooser_get_uri()`, `gtk_file_chooser_get_uris()`.

#### Parameters

chooser | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“selection-changed”` signal

    void
    user_function (GtkFileChooser *chooser,
                   gpointer        user_data)

This signal is emitted when there is a change in the set of selected files in a GtkFileChooser. This can happen when the user modifies the selection with the mouse or the keyboard, or when explicitly calling functions to change the selection.

Normally you do not need to connect to this signal, as it is easier to wait for the file chooser to finish running, and then to get the list of selected files using the functions mentioned below.

See also: `gtk_file_chooser_select_filename()`, `gtk_file_chooser_unselect_filename()`, `gtk_file_chooser_get_filename()`, `gtk_file_chooser_get_filenames()`, `gtk_file_chooser_select_uri()`, `gtk_file_chooser_unselect_uri()`, `gtk_file_chooser_get_uri()`, `gtk_file_chooser_get_uris()`.

#### Parameters

chooser | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“update-preview”` signal

    void
    user_function (GtkFileChooser *chooser,
                   gpointer        user_data)

This signal is emitted when the preview in a file chooser should be regenerated. For example, this can happen when the currently selected file changes. You should use this signal if you want your file chooser to have a preview widget.

Once you have installed a preview widget with `gtk_file_chooser_set_preview_widget()`, you should update it when this signal is emitted. You can use the functions `gtk_file_chooser_get_preview_filename()` or `gtk_file_chooser_get_preview_uri()` to get the name of the file to preview. Your widget may not be able to preview all kinds of files; your callback must call `gtk_file_chooser_set_preview_widget_active()` to inform the file chooser about whether the preview was generated successfully or not.

Please see the example code in Using a Preview Widget.

See also: `gtk_file_chooser_set_preview_widget()`, `gtk_file_chooser_set_preview_widget_active()`, `gtk_file_chooser_set_use_preview_label()`, `gtk_file_chooser_get_preview_filename()`, `gtk_file_chooser_get_preview_uri()`.

#### Parameters

chooser | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

## See Also

GtkFileChooserDialog, GtkFileChooserWidget, GtkFileChooserButton